
// 	***********************************************************************
//	File : SPI_MASTER.c
//	***********************************************************************

#include 	<p30F4011.h>
#include 	"C30EVM_LCD.h"			// NLCD禡쫬ŧiɮקtJ 
#include	<timer.h>				// NTimer禡쫬ŧiɮקtJ
#include	<adc10.h>				// Nadc10禡쫬ŧiɮקtJ
#include	"ADCSubs.h"
#include	"SPISubs.h"

#define		FCY 	7372800 * 2		// ]ϥWvN~ 7.3728 MHz * 8 Ҧ , C@Og 4  clock
									// ҥH FCY =  (7.3728 * 8 / 4 ) MHz = 7372800* 2

   	_FOSC(CSW_FSCM_OFF & XT_PLL8);   //	XT with 8xPLL oscillator, Failsafe clock off
   	_FWDT(WDT_OFF);                  //	Watchdog timer disabled
  	_FBORPOR(PBOR_OFF & MCLR_EN);    //	Brown-out reset disabled, MCLR reset enabled
   	_FGS(CODE_PROT_OFF);             //	Code protect disabled

const char	My_String1[]="MCP4921 OUT:    " ;	// ŧir Program Memory (] const ŧi)
	  char	My_String2[]="Ext. AN0 IN:    " ;	// ŧir Data Memory

unsigned int miliSec ;

void	Init_ADC(void) ;
void	Show_ADC(void) ;
void	SPI_Delay(void) ;
void	Update_DA_ADC(void);

// union ŧiN8줸ܼByteAccessPSystemFlagcܼƨϥάۦPOA
// HQP榡줸BݨD
union 	{
			unsigned char ByteValue ;
			struct 	{
						unsigned Bit0: 1 ;
						unsigned Bit1: 1 ;
						unsigned Bit2: 1 ;
						unsigned unused : 5 ;
					} ;
		} SystemFlag ;

//wqOneSecondXеPSystemFlag.Bit0줸ܼơAGNϥΤ@Ӧ줸OЪŶ
#define	OneSecond	SystemFlag.Bit0 

#define	SW5		PORTEbits.RE8
#define	SW6		PORTBbits.RB3

#define	CTRL_SW5	TRISEbits.TRISE8
#define	CTRL_SW6	TRISBbits.TRISB3

void _ISR _T1Interrupt(void)		//Timer1_Ƶ{
{

	miliSec += 1 ;

	if (miliSec == 1000)		//C1000NOneSecondXг]w1
		{
			OneSecond = 1 ;
			miliSec  = 0 ;
		} 
	IFS0bits.T1IF = 0 ;		//M_X

}


	unsigned int	DA_Value = 512 ;
	unsigned int 	ADC_Value;
	unsigned char 	EEPROM_Data1 , EEPROM_Data2 ;
	unsigned char	SPI_Status ;

	unsigned int	SW5_OnCounter = 0 ;
	unsigned int	SW6_OnCounter = 0 ;

				//	-------------------------------------------------
				//	ϥ dsPIC30F4011  SPI ӱ MCP4921
				//	Control Pins :
				//  RB2 -- 	DSW6 Pin-5& Pin-6 , Ψӧ@ SPI  CS 
				//	SDI --  DSW6 Pin-3	( dsPIC30F4011  Pin-26 )
				//  SDO -- 	DSW6 Pin-4	( dsPIC30F4011  Pin-25 )
				//
				//	m߷|ˬd SW5 & SW6 ӫӼW/ DA_Value
				//  DA_Value ΨӿX MCP4921 , CON14  Pin-1
				// 	CON14  Pin-1 ݥΧu CON5  PIN-4 
				//  ]NO AN0/RB0 }
				//	>> ۴NiH AN0 ŪJ MCP4921 XF ...
				//  >> ] MCP4921  12-bit  DAC , ҥHbXɷ|N 
				//     DA_Value(0..1023) ȥH 4 AX MCP4921
				//
				//	>> 	m߻ݪ`N DIP SW & Jumper ]w
				//		DSW1 bN{n 3&4=ON , 1&2 = OFF
				//			-- EMUC & EMUD nd@ SPI }
				//		DSW6 bN{ɭn OFF , N 3&4*5 = ON
				//			-- SPI }챱 MCP4921
				//		DSW3 1=OFF , 3=ON ,  CON5 Pin-4  AN0/RB0
				//			-- VR2 qN|iJ AN0/RB0
 				// 	----------------------------------------------------------
			

int	main( void )
{

	CTRL_SW5 = 1 ;
	CTRL_SW6 = 1 ;


	Init_ADC( ) ;										// NADCilƳ]w
	Init_SPI( ) ;

	OpenLCD( ) ;										// ϥ OpenLCD( ) LCD Ҳէ@lƳ]w
														// 4 bits Data mode
														// 5 * 7 Character 

	setcurLCD(0,0) ;									// ϥ setcurLCD( ) ]wЩ (0,0)
	putrsLCD( My_String1 ) ;							// Nsb Program Memory rϥ
														// putrsLCD( ) LX LCD
			
	setcurLCD(0,1) ;									// ϥ setcurLCD( ) ]wЩ (0,1)
	putrsLCD( My_String2 ) ;							// Nsb Data Memory rϥ
														// putsLCD( ) LX LCD

	ConfigIntTimer1( T1_INT_PRIOR_7 & T1_INT_ON ) ;		// Timer1 _uų] 7 (̰)
														// Timer1 _ ON 

	OpenTimer1( T1_ON & T1_IDLE_STOP & T1_GATE_OFF & 			// Timer1  Period ]C 1ms 
				T1_PS_1_1 & T1_SYNC_EXT_OFF & T1_SOURCE_INT ,
				(FCY/ 1000) ) ;

	OneSecond = 0 ;

		SPI_EEPROM_StsWrite(0x00 ) ;
		SPI_Delay() ;

	while(1) 
	{	

		if (!SW5 )
			{
				SW5_OnCounter ++ ;
				if ( SW5_OnCounter >= 20000)
				{
					SW5_OnCounter = 0 ;
					Update_DA_ADC( );
					if (DA_Value < 1023 )	DA_Value ++ ;
				}
			}

		else if (!SW6)
			{
				SW6_OnCounter ++ ;
				if ( SW6_OnCounter >= 20000)
				{
					SW6_OnCounter = 0 ;
					Update_DA_ADC( );
					if (DA_Value > 0) 	DA_Value -- ;
				}
			}
		if ( OneSecond ) 								// ߰ Timer1  Period ɶO_w
														// iHγnˬdO_ǽT 1 ms
		{
			OneSecond = 0 ;	
			Nop() ;						 
		

			ADC_Value = Get_VR2( ) ;								
			setcurLCD(12,1) ;							// Set LCD cursor		
			put_int_LCD( ADC_Value ) ;				// NഫGHQiƦrܦܲGܾ

			SPI_MCP4921_Write( DA_Value ) ;

			setcurLCD(12,0) ;							// Set LCD cursor		
			put_int_LCD( DA_Value ) ;						

		}
	}		
}

void	Update_DA_ADC(void)
{
			ADC_Value = Get_VR2( ) ;								
			setcurLCD(12,1) ;							// Set LCD cursor		
			put_int_LCD( ADC_Value ) ;				// NഫGHQiƦrܦܲGܾ

			SPI_MCP4921_Write( DA_Value ) ;

			setcurLCD(12,0) ;							// Set LCD cursor		
			put_int_LCD( DA_Value ) ;			
}


void	SPI_Delay(void)
{
	int	LoopSPI ;
	for (LoopSPI = 0 ; LoopSPI < 100 ; LoopSPI ++ ) ;

}
